//----------------------------------------------------------------------//
//	IdeaFragment2														//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>

//---------------------------------------------------------------------
USEFORM("MapView.cpp", MapViewer);
USEFORM("OptIdDlg.cpp", OptIndDlg);
USEFORM("OptDlg.cpp", OptionDlg);
USEFORM("Main.cpp", IdeaFragMainForm);
USEFORM("Stretch.cpp", StretchDlg);
USEFORM("PropDlg.cpp", FrgPropDlg);
USEFORM("RubrLay.cpp", RubLayDlg);
USEFORM("FindEx.cpp", FindExForm);
USEFORM("FindDlg.cpp", FindSetDlg);
USEFORM("about.cpp", AboutBox);
USEFORM("ChildWin.cpp", MDIChild);
USEFORM("FrgGrid.cpp", FragGrid);

//---------------------------------------------------------------------------
WINAPI _tWinMain(HINSTANCE, HINSTANCE, LPTSTR lpCmdLine, int)
{
	//~[ebNXɂdN𔻒
	HANDLE hMutex = ::CreateMutex(NULL,FALSE, _T("IdeaFragment2_is_running"));
	if (::GetLastError()==ERROR_ALREADY_EXISTS) {
		HWND hPrevWnd = ::FindWindow(_T("TIdeaFragMainForm"), NULL);
		if (hPrevWnd) {
			// IdeaFragment2 ANeBu
			HWND hApp	  = ::GetWindow(hPrevWnd, GW_OWNER);
			HWND hPrevPop = ::GetLastActivePopup(hApp);
			if (::IsIconic(hApp)) ::SendMessage(hApp, WM_SYSCOMMAND, SC_RESTORE, 0);
			::SetForegroundWindow(hPrevPop);
			//R}hC̓e𑗂
			COPYDATASTRUCT cd;
			cd.dwData = 1;
			cd.cbData = sizeof(_TCHAR) * (lstrlen(lpCmdLine) + 1);
			cd.lpData = lpCmdLine;
			::SendMessage(hPrevWnd, WM_COPYDATA, 0, (LPARAM)&cd);
		}
		::CloseHandle(hMutex);
		return -1;
	}

	::CoInitialize(NULL);

	try
	{
		Application->Initialize();
		Application->Title = "IdeaFragment2";
		Application->CreateForm(__classid(TIdeaFragMainForm), &IdeaFragMainForm);
		Application->CreateForm(__classid(TMapViewer), &MapViewer);
		Application->CreateForm(__classid(TFrgPropDlg), &FrgPropDlg);
		Application->CreateForm(__classid(TFindSetDlg), &FindSetDlg);
		Application->CreateForm(__classid(TStretchDlg), &StretchDlg);
		Application->CreateForm(__classid(TOptionDlg), &OptionDlg);
		Application->CreateForm(__classid(TOptIndDlg), &OptIndDlg);
		Application->CreateForm(__classid(TAboutBox), &AboutBox);
		Application->CreateForm(__classid(TFragGrid), &FragGrid);
		Application->CreateForm(__classid(TFindExForm), &FindExForm);
		Application->CreateForm(__classid(TRubLayDlg), &RubLayDlg);
		Application->Run();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	catch (...)
	{
		try
		{
			throw Exception("");
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
	}

	::CoUninitialize();
	CloseHandle(hMutex);
	return 0;
}
//---------------------------------------------------------------------
